import * as i0 from '@angular/core';
import { Injectable, EventEmitter, Component, Input, Output, NgModule } from '@angular/core';

class EmailEditorService {
    constructor() { }
}
EmailEditorService.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.2.10", ngImport: i0, type: EmailEditorService, deps: [], target: i0.ɵɵFactoryTarget.Injectable });
EmailEditorService.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "15.2.10", ngImport: i0, type: EmailEditorService, providedIn: 'root' });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.2.10", ngImport: i0, type: EmailEditorService, decorators: [{
            type: Injectable,
            args: [{
                    providedIn: 'root'
                }]
        }], ctorParameters: function () { return []; } });

const defaultScriptUrl = 'https://editor.unlayer.com/embed.js?2';
const callbacks = [];
let loaded = false;
const isScriptInjected = (scriptUrl) => {
    const scripts = document.querySelectorAll('script');
    let injected = false;
    scripts.forEach((script) => {
        if (script.src.includes(scriptUrl)) {
            injected = true;
        }
    });
    return injected;
};
const addCallback = (callback) => {
    callbacks.push(callback);
};
const runCallbacks = () => {
    if (loaded) {
        let callback;
        while ((callback = callbacks.shift())) {
            callback();
        }
    }
};
const loadScript = (callback, scriptUrl = defaultScriptUrl) => {
    addCallback(callback);
    if (!isScriptInjected(scriptUrl)) {
        const embedScript = document.createElement('script');
        embedScript.setAttribute('src', scriptUrl);
        embedScript.onload = () => {
            loaded = true;
            runCallbacks();
        };
        document.head.appendChild(embedScript);
    }
    else {
        runCallbacks();
    }
};

var name = "angular-email-editor";
var version = "15.2.0";
var peerDependencies = {
    "unlayer-types": "latest"
};
var dependencies = {
    tslib: "^2.3.0"
};
var pkg = {
    name: name,
    version: version,
    peerDependencies: peerDependencies,
    dependencies: dependencies
};

let lastEditorId = 0;
class EmailEditorComponent {
    constructor() {
        this.options = {};
        this.minHeight = '500px';
        this.loaded = new EventEmitter();
        this.ready = new EventEmitter();
        this.id = this.editorId || `editor-${++lastEditorId}`;
    }
    ngOnInit() { }
    ngAfterViewInit() {
        loadScript(this.loadEditor.bind(this), this.scriptUrl);
    }
    loadEditor() {
        const options = this.options || {};
        if (this.projectId) {
            options.projectId = this.projectId;
        }
        if (this.tools) {
            options.tools = this.tools;
        }
        if (this.appearance) {
            options.appearance = this.appearance;
        }
        if (this.locale) {
            options.locale = this.locale;
        }
        this.editor = unlayer.createEditor(Object.assign(Object.assign({}, options), { id: this.id, displayMode: 'email', source: {
                name: pkg.name,
                version: pkg.version,
            } }));
        this.loaded.emit({});
        this.editor.addEventListener('editor:ready', () => {
            this.ready.emit({});
        });
    }
    loadDesign(data) {
        this.editor.loadDesign(data);
    }
    saveDesign(cb) {
        this.editor.saveDesign(cb);
    }
    exportHtml(cb) {
        this.editor.exportHtml(cb);
    }
}
EmailEditorComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.2.10", ngImport: i0, type: EmailEditorComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
EmailEditorComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "15.2.10", type: EmailEditorComponent, selector: "email-editor", inputs: { editorId: "editorId", options: "options", projectId: "projectId", scriptUrl: "scriptUrl", tools: "tools", appearance: "appearance", locale: "locale", id: "id", minHeight: "minHeight" }, outputs: { loaded: "loaded", ready: "ready" }, ngImport: i0, template: "<div [id]=\"id\" class=\"unlayer-editor\" [style.min-height]=\"minHeight\"></div>\n", styles: [":host{flex:1;display:flex}.unlayer-editor{flex:1;display:flex}\n"] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.2.10", ngImport: i0, type: EmailEditorComponent, decorators: [{
            type: Component,
            args: [{ selector: 'email-editor', template: "<div [id]=\"id\" class=\"unlayer-editor\" [style.min-height]=\"minHeight\"></div>\n", styles: [":host{flex:1;display:flex}.unlayer-editor{flex:1;display:flex}\n"] }]
        }], ctorParameters: function () { return []; }, propDecorators: { editorId: [{
                type: Input
            }], options: [{
                type: Input
            }], projectId: [{
                type: Input
            }], scriptUrl: [{
                type: Input
            }], tools: [{
                type: Input
            }], appearance: [{
                type: Input
            }], locale: [{
                type: Input
            }], id: [{
                type: Input
            }], minHeight: [{
                type: Input
            }], loaded: [{
                type: Output
            }], ready: [{
                type: Output
            }] } });

class EmailEditorModule {
}
EmailEditorModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.2.10", ngImport: i0, type: EmailEditorModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
EmailEditorModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "15.2.10", ngImport: i0, type: EmailEditorModule, declarations: [EmailEditorComponent], exports: [EmailEditorComponent] });
EmailEditorModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "15.2.10", ngImport: i0, type: EmailEditorModule });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.2.10", ngImport: i0, type: EmailEditorModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [EmailEditorComponent],
                    imports: [],
                    exports: [EmailEditorComponent]
                }]
        }] });

/*
 * Public API Surface of email-editor
 */

/**
 * Generated bundle index. Do not edit.
 */

export { EmailEditorComponent, EmailEditorModule, EmailEditorService };
//# sourceMappingURL=angular-email-editor.mjs.map
